/*
 *	mapper.c
 *
 *	Famicom/EMU
 *
 *	* Thu Feb 03 00:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static int prgrom_bank[2];
static int chrrom_bank[1];

/****************************************************************************
 *	
 ****************************************************************************/

static int init_00() {
	/* PRG-ROM */
	if(ines->prgrom_page_count < 1) return -1;
	prgrom_bank[0] = 0;
	copy_16k(&m6502mem[0x8000], prgrom[prgrom_bank[0]]);
	prgrom_bank[1] = ines->prgrom_page_count - 1;
	copy_16k(&m6502mem[0xc000], prgrom[prgrom_bank[1]]);

	/* CHR-ROM */
	if(ines->chrrom_page_count) {
		chrrom_bank[0] = 0;
		copy_8k(&ppu_vram[0x0000], chrrom[chrrom_bank[0]]);
	}

	return 0;
}

static const MAPPER mapper_00 = { init_00, NULL };

/****************************************************************************
 *	
 ****************************************************************************/

static int init_02() {
	/* PRG-ROM */
	if(ines->prgrom_page_count < 1) return -1;
	prgrom_bank[0] = 0;
	copy_16k(&m6502mem[0x8000], prgrom[prgrom_bank[0]]);
	prgrom_bank[1] = ines->prgrom_page_count - 1;
	copy_16k(&m6502mem[0xc000], prgrom[prgrom_bank[1]]);

	/* use CHR-RAM (no CHR-ROM) */

	return 0;
}

static void write_02(int addr, int data) {
	/* PRG-ROM */
	data %= ines->prgrom_page_count;
	if(prgrom_bank[0] != data) {
		prgrom_bank[0] = data;
		copy_16k(&m6502mem[0x8000], prgrom[prgrom_bank[0]]);
	}
}

static const MAPPER mapper_02 = { init_02, write_02 };

/****************************************************************************
 *	
 ****************************************************************************/

static int init_03() {
	/* PRG-ROM */
	if(ines->prgrom_page_count < 1) return -1;
	prgrom_bank[0] = 0;
	copy_16k(&m6502mem[0x8000], prgrom[prgrom_bank[0]]);
	prgrom_bank[1] = ines->prgrom_page_count - 1;
	copy_16k(&m6502mem[0xc000], prgrom[prgrom_bank[1]]);

	/* CHR-ROM */
	if(ines->chrrom_page_count) {
		chrrom_bank[0] = 0;
		copy_8k(&ppu_vram[0x0000], chrrom[chrrom_bank[0]]);
	}

	return 0;
}

static void write_03(int addr, int data) {
	/* CHR-ROM */
	if(ines->chrrom_page_count) {
		data %= ines->chrrom_page_count;
		if(chrrom_bank[0] != data) {
			chrrom_bank[0] = data;
			copy_8k(&ppu_vram[0x0000], chrrom[chrrom_bank[0]]);
		}
	}
}

static const MAPPER mapper_03 = { init_03, write_03 };

/****************************************************************************
 *	
 ****************************************************************************/

const MAPPER* const mapper_list[256] = {
/*00*/	&mapper_00,
/*01*/	NULL,
/*02*/	&mapper_02,
/*03*/	&mapper_03,
};
